// (c) Copyright 2013 Cloudera, Inc. All rights reserved.

define(["cloudera/impala/QuerySearch","cloudera/Util","cloudera/chart/TimeRange","cloudera/common/UrlParams","underscore"],function(e,t,n,r,i){describe("QuerySearch",function(){var s,o,u,a,f,l,c=function(e){var t=[];return i.times(e,function(e){t.push({startTime:1348766817260+1e6*e,endTime:1348767817260+1e6*e,statement:"query "+e})}),{queries:t}},h=function(e){var t={startTime:{millis:e+1e3},endTime:{millis:e+2e3},duration:{millis:e+3e3}};return e>=10&&(t.endTime=null),t};beforeEach(function(){u=$("<div></div>").appendTo(document.body),f=$("<div></div>").appendTo(document.body),a=$('<div class="event-list"></div>').appendTo(document.body),l=$("<div></div>").appendTo(document.body),o={filterContainer:u[0],queryInputContainer:f,queriesContainer:l[0],executingQueriesUrl:"/some/random/query/executing",completedQueriesUrl:"/some/random/query/completed",cancelQueryUrl:"/cancel/query/url",serviceName:"testServiceName",updateRecentFiltersUrl:"/update/recent/filters",getRecentFiltersUrl:"/get/recent/filters"},jasmine.Ajax.useMock(),s=new e(o)}),afterEach(function(){u.remove(),a.remove(),l.remove(),s&&t.unsubscribe(s)}),it("maintains search results",function(){expect(s.searchResults).toBeDefined()}),it("enables tooltips",function(){t.unsubscribe(s),spyOn($.fn,"tooltip"),s=new e(o),expect($.fn.tooltip).wasCalled()}),it("enables typeahead of the query input container",function(){spyOn($.fn,"SimpleTypeahead"),t.unsubscribe(s),s=new e(o),expect($.fn.SimpleTypeahead).wasCalled()}),it("subscribes to time changed events",function(){t.unsubscribe(s),spyOn($,"subscribe"),s=new e(o),expect($.subscribe).wasCalledWith("timeSelectionChanged",jasmine.any(Function)),s=null}),it("ignores auto update",function(){spyOn(s.searchResults,"setDates");var e=new n(new Date,new Date);s.onTimeSelectionChanged(e,!0,!0),expect(s.searchResults.setDates).wasNotCalled()}),it("resets query based on time params",function(){spyOn(s.searchResults,"setDates"),spyOn(s,"loadData");var e=new n(new Date(0),new Date(1e3));s.onTimeSelectionChanged(e,!1,!1),expect(s.searchResults.setDates).wasCalledWith(new Date(0),new Date(1e3),!1)}),it("searches correctly",function(){spyOn(s,"updateUrlParamsFromQuery"),spyOn(s,"loadData"),s.search(),expect(s.updateUrlParamsFromQuery).wasCalled(),expect(s.loadData).wasCalledWith(!0)}),it("updates query from url params",function(){var n=0,i=[],u=function(e){return i.push(e),n+=1,n};spyOn(r,"get").andCallFake(u),spyOn(r,"getInt").andCallFake(u),t.unsubscribe(s),s=new e(o),expect(s.filters()).toEqual(1),expect(i.length).toEqual(3),expect(i[0]).toEqual("filters"),expect(i[1]).toEqual("startTime"),expect(i[2]).toEqual("endTime")}),it("updates query correctly in the presence of invalid dates",function(){r.params.startTime="invalid start time",r.params.endTime="invalid end time",t.unsubscribe(s),s=new e(o),expect(isNaN(s.searchResults.query.startTime.getTime())).toBeFalsy(),expect(isNaN(s.searchResults.query.endTime.getTime())).toBeFalsy()}),it("updates query filters as undefined initially",function(){expect(s.filters()).toEqual(undefined)}),it("updates url from query when searching",function(){spyOn(r,"set"),s.filters("catpants"),s.updateUrlParamsFromQuery(),expect(r.set).wasCalled();var e=r.set.mostRecentCall.args[1];expect(e).toEqual("catpants")}),it("removes filters from url if there are no filters",function(){spyOn(r,"set"),spyOn(r,"remove"),s.filters(""),s.updateUrlParamsFromQuery(),expect(r.remove).wasCalled(),expect(r.set).wasNotCalled()}),it("does not error out if filters is undefined",function(){spyOn(r,"set"),spyOn(r,"remove"),s.filters(undefined),s.updateUrlParamsFromQuery(),expect(r.remove).wasCalled(),expect(r.set).wasNotCalled()}),it("can load data correctly",function(){spyOn(s.searchResults,"loadData"),s.loadData(),expect(s.searchResults.loadData).wasCalled()}),describe("filterViewModel",function(){var e;beforeEach(function(){e=s.filterViewModel}),it("tracks filters",function(){s.filters("catpants doggyhat"),expect(e.filters()).toEqual("catpants doggyhat")}),it("knows how to search",function(){expect(e.search).toEqual(s.search)}),it("searches on enter keypress",function(){spyOn(s,"search"),expect(e.searchOnEnter(null,{which:42})).toBeTruthy(),expect(s.search).wasNotCalled(),expect(e.searchOnEnter(null,{which:13})).toBeFalsy(),expect(s.search).wasCalled()}),it("supports suggested filters",function(){spyOn(s,"filters"),spyOn(s,"search");var t=$('<div data-filter="here is my filter">Hello there</div>').appendTo(document.body);e.useSuggestedFilter(null,{target:t[0]}),expect(s.filters).wasCalledWith("here is my filter"),expect(s.search).wasCalled(),t.remove()}),it("supports recent filters",function(){spyOn(s,"filters"),spyOn(s,"search"),e.useFilter("catpants"),expect(s.filters).wasCalledWith("catpants"),expect(s.search).wasCalled()})}),describe("recent filters",function(){beforeEach(function(){jasmine.Ajax.useMock()}),it("gets recent filters on instantiation",function(){var e=mostRecentAjaxRequest(),t=!1;i.each(ajaxRequests,function(e){t=t||e.url===o.getRecentFiltersUrl}),expect(t).toBeTruthy()}),it("can get recent filters",function(){s.getRecentFilters();var e=mostRecentAjaxRequest();expect(e.url).toEqual(o.getRecentFiltersUrl),e.response({status:200,responseText:JSON.stringify(["recentFilter1","recentFilter2"])});var t=s.recentFilters();expect(t.length).toEqual(2),expect(t[0]).toEqual("recentFilter1"),expect(t[1]).toEqual("recentFilter2")}),it("can update recent filters",function(){s.filters("select the cat where dog"),s.updateRecentFilters();var e=mostRecentAjaxRequest();expect(e.url).toEqual(o.updateRecentFiltersUrl),expect(e.params).toEqual("filters=select+the+cat+where+dog")}),it("does not update recent filters if filter is empty",function(){spyOn($,"post").andCallThrough(),s.filters("select the cat where dog"),s.updateRecentFilters(),expect($.post).wasCalled(),$.post.reset(),s.filters(""),s.updateRecentFilters(),expect($.post).wasNotCalled(),s.filters(undefined),s.updateRecentFilters(),expect($.post).wasNotCalled()})}),it("will fire its onTimeSelectionChanged method if it missed the initialtime selection changed event",function(){spyOn(s,"onTimeSelectionChanged"),window._currentTimeSelection=null,s.checkInitialTimeRange(),expect(s.onTimeSelectionChanged).wasNotCalled(),window._currentTimeSelection={timeRange:"timeRange",isCurrentMode:"isCurrentMode",isAutoUpdate:"isAutoUpdate"},s.checkInitialTimeRange(),expect(s.onTimeSelectionChanged).wasCalledWith("timeRange","isCurrentMode","isAutoUpdate")})})})